=== debian/changelog ===
libbson (1.3.1-1) experimental; urgency=low

  * New upstream release
  * Add symbols file for stable ABI, thanks to Ondřej Surý

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 19 Jan 2016 19:29:33 +0000

libbson (1.2.1-1) experimental; urgency=low

  * Initial release (Closes: #798695)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Fri, 16 Oct 2015 14:52:26 -0400
