## libbson 1.3.5

=== debian/changelog ===
libbson (1.3.5-1) unstable; urgency=low

  [ A. Jesse Jiryu Davis ]
  * New upstream release.
  * Fix man-pages install command.
  * Remove obsolete copyrights entry.
  * Updated to Standards-Version 3.9.8 (no changes)

  [ Ondřej Surý ]
  * Remove -dbg package and add a simple BC compatible dbgsym support

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 17 May 2016 12:12:28 -0400
