=== debian/rules ===
--- 
+++ 
@@ -30,12 +30,11 @@
 
 override_dh_auto_build:
 	dh_auto_build
-	make html
+	make man html
 
 override_dh_auto_clean:
 	dh_auto_clean
 	[ ! -f README ] || /bin/rm -f README
 
 override_dh_strip:
-	dh_strip -a --dbg-package=libbson-dbg
-
+	dh_strip --dbgsym-migration='libbson-dbg (<< 1.3.1-2~)' || dh_strip
