=== debian/rules ===
--- 
+++ 
@@ -30,7 +30,7 @@
 
 override_dh_auto_build:
 	dh_auto_build
-	make man html
+	make man doc/html
 
 override_dh_auto_clean:
 	dh_auto_clean
