## libbson 1.5.4

=== debian/changelog ===
libbson (1.5.4-1ubuntu2) zesty; urgency=medium

  * Really turn off the testsuite for now on all archs as they segfault. 

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 19 Feb 2017 10:48:24 +0530

libbson (1.5.4-1ubuntu1) zesty; urgency=medium

  * Turn off the test suite on arm* archs for now as they segfault. 

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 19 Feb 2017 09:55:36 +0530

libbson (1.5.4-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Mon, 30 Jan 2017 16:39:59 +0000

libbson (1.5.3-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Thu, 12 Jan 2017 16:50:07 +0000

libbson (1.5.0-1) unstable; urgency=low

  * New upstream release
  * Refresh use_system_yajl.patch for libbson 1.5.0
  * Remove symbols file

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 29 Nov 2016 03:57:33 +0000
