=== debian/rules ===
--- 
+++ 
@@ -16,8 +16,6 @@
 # package maintainers to append LDFLAGS
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
-export DPKG_GENSYMBOLS_CHECK_LEVEL=4
-
 # main packaging script based on dh7 syntax
 %:
 	dh $@ --with autoreconf
@@ -32,6 +30,8 @@
 	dh_auto_build
 	make man doc/html
 
+override_dh_auto_test:
+
 override_dh_auto_clean:
 	dh_auto_clean
 	[ ! -f README ] || /bin/rm -f README
