## libbson 1.8.0

=== debian/changelog ===
libbson (1.8.0-1) unstable; urgency=low

  * New upstream release (Closes: #874754)
  * Include cmake config files (Closes: #876194)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Thu, 14 Sep 2017 19:45:21 +0000

libbson (1.7.0-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Fri, 11 Aug 2017 02:34:43 +0000

libbson (1.6.3-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 23 May 2017 20:45:01 +0000

libbson (1.6.1-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 07 Mar 2017 20:47:35 +0000
