=== debian/control ===
--- 
+++ 
@@ -1,12 +1,9 @@
 Source: libbson
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: A. Jesse Jiryu Davis <jesse@mongodb.com>
+Maintainer: A. Jesse Jiryu Davis <jesse@mongodb.com>
 Build-Depends: debhelper (>= 9),
                dh-autoreconf,
-               libyajl-dev,
-               yelp-tools,
-               yelp-xsl
+               python3-sphinx
 Standards-Version: 3.9.8
 Section: libs
 Homepage: https://github.com/mongodb/libbson
