=== debian/changelog ===
libbson (1.9.2-1) unstable; urgency=low

  * New upstream release
  * Update to Standards-Version 4.1.3 (no changes)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Fri, 12 Jan 2018 12:48:01 -0500

libbson (1.9.0-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Wed, 20 Dec 2017 20:24:49 +0000

libbson (1.8.1-1) unstable; urgency=low

  * New upstream release
  * Update to Standards-Version 4.1.1 (no changes)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Thu, 12 Oct 2017 15:55:23 +0000
