=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Build-Depends: debhelper (>= 9),
                dh-autoreconf,
                python3-sphinx
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Section: libs
 Homepage: https://github.com/mongodb/libbson
 Vcs-Git: https://github.com/mongodb/libbson.git
