=== debian/rules ===
--- 
+++ 
@@ -24,13 +24,11 @@
 	dh_auto_configure -- \
 	--prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --enable-debug-symbols=yes --enable-html-docs=yes --enable-man-pages=yes --enable-maintainer-flags=yes 
 	# Upstream's autogen.sh creates this symlink, but dh-autoreconf doesn't
-	[ -f README ] || /bin/cp README.md README
+	[ -f README ] || /bin/cp README.rst README
 
 override_dh_auto_build:
 	dh_auto_build
-	make man doc/html
-
-override_dh_auto_test:
+	make doc/man doc/html
 
 override_dh_auto_clean:
 	dh_auto_clean
