=== debian/watch ===
version=3

https://github.com/mongodb/libbson/releases /mongodb/libbson/releases/download/\d\S*/libbson-(\d\S*)\.tar\.gz
