## libbson 1.9.5

=== debian/changelog ===
libbson (1.9.5-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Mon, 30 Apr 2018 22:22:18 -0400

libbson (1.9.4-1) unstable; urgency=low

  * New upstream release
  * Update to Standards-Version 4.1.4 (no changes)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 10 Apr 2018 07:56:49 -0400

libbson (1.9.3-1) unstable; urgency=low

  * New upstream release

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Fri, 02 Mar 2018 11:31:53 -0500
